# Copyright (c) 2009 gocept gmbh & co. kg
# See also LICENSE.txt

import gocept.directory.interfaces
from zope.app.zopeappgenerations import getRootFolder
import zope.app.component.hooks
import zope.component


def evolve(context):
    """Remove superfluous registrations of deleted nodes."""
    root = getRootFolder(context)
    d = root['directory']
    site_manager = d.getSiteManager()
    for name, node in site_manager.getUtilitiesFor(
            gocept.directory.interfaces.INode):
        if node.__name__ is None:
            assert site_manager.unregisterUtility(
                node, provided=gocept.directory.interfaces.INode, name=name)
    zope.app.component.hooks.setSite(None)
