# Copyright (c) 2009 gocept gmbh & co. kg
# See also LICENSE.txt

import gocept.directory.interfaces
from zope.app.zopeappgenerations import getRootFolder
import zope.app.component.hooks


def evolve(context):
    """Remove service-user entries from all nodes."""
    root = getRootFolder(context)
    d = root['directory']
    site_manager = d.getSiteManager()
    for name, node in site_manager.getUtilitiesFor(
            gocept.directory.interfaces.INode):
        try:
            del node.service_users
        except:
            pass
    zope.app.component.hooks.setSite(None)
